Unit MNI25_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNI25(GRAD :Proc_F5_MN; N :Integer; M :Integer; L :Integer;
                var X :Array of Real; var F :Array of Real;
                var G :Array of Real; var I0 :Array of Integer;
                var R1 :Array of Real);

implementation

procedure MNI25(GRAD :Proc_F5_MN; N :Integer; M :Integer; L :Integer;
                var X :Array of Real; var F :Array of Real;
                var G :Array of Real; var I0 :Array of Integer;
                var R1 :Array of Real);
var
I,J :Integer;
R,GE :Real;
label
_5,_10,_15,_20,_25,_30;
begin
_MNI1.elm5 := _MNI1.elm5+1;
GE := 0;
J := 2;
for I:=1 to N do
 begin
_5:
  R1[(I-1)+1*N] := 0.0;
 end;
_10:
if ( J > L ) 
 then goto _25;
if ( F[J-1] <= 0 ) and ( J <= M ) 
 then goto _20;
I0[N+0] := J;
R := Power(Abs(F[J-1]),_MNI1.elm2);
GRAD(X,R1[0+0*N],GE,I0);
for I:=1 to N do
 begin
_15:
  R1[(I-1)+1*N] := R1[(I-1)+1*N]+_MNI1.elm1*R1[(I-1)+0*N]*Sign(R,F[J-1]);
 end;
_20:
J := J+1;
goto _10;
_25:
I0[N+0] := 1;
GRAD(X,R1[0+0*N],GE,I0);
for I:=1 to N do
 begin
_30:
  G[I-1] := R1[(I-1)+0*N]+_MNI1.elm3*R1[(I-1)+1*N];
 end;
end;

end.
